import { MuClient } from 'mudb/client';
import { MuRPCProtocolSchema, MuRPCTable, MuRPCInterface } from './rpc';
export declare class MuRemoteRPCServer<Schema extends MuRPCTable> {
    readonly rpc: MuRPCInterface<Schema>['callerAPI'];
    constructor(rpc: MuRPCInterface<Schema>['callerAPI']);
}
export declare class MuRPCClient<ProtocolSchema extends MuRPCProtocolSchema> {
    readonly schema: ProtocolSchema;
    readonly sessionId: string;
    readonly client: MuClient;
    readonly server: MuRemoteRPCServer<ProtocolSchema['server']>;
    private _callProtocol;
    private _responseProtocol;
    private _errorProtocol;
    private _callbacks;
    private _createPRCToServer;
    constructor(client: MuClient, schema: ProtocolSchema);
    configure(spec: {
        rpc: MuRPCInterface<ProtocolSchema['client']>['clientHandlerAPI'];
        ready?: () => void;
        close?: () => void;
    }): void;
}
